#include <stdio.h>
#include <stdlib.h>

#include "libClient.h"

int main (int argc, char **argv)
{
    Jeu jeu;
    Moi moi;
    Adversaire adversaire;
    int nbBoules;
    Boule boule[BOULES_NB_MAX];
    int etat;

    // adresse IP du serveur sous forme de chaine de caracteres
    char adresse[255] = "127.0.0.1";
    // numero du port du serveur
    int port = 1050;

    if (serveurConnecter(adresse, port) != SERVEUR_CONNECTE) {
        printf("Serveur introuvable %s:%d\n", adresse, port);
        exit(-1);
    } else {
        printf("Connexion au serveur %s:%d\n", adresse, port);
    }

    serveurUpload(IMAGE_DEBOUT, "../images/debout.png");
    serveurUpload(IMAGE_MARCHE, "../images/marche.png");
    serveurUpload(IMAGE_ACCROUPI, "../images/accroupi.png");
    serveurUpload(IMAGE_LANCE, "../images/lance.png");
    serveurUpload(IMAGE_BONNET_PROFIL, "../images/bonnet_profil.png");
    serveurUpload(IMAGE_VICTOIRE, "../images/victoire.png");
    serveurUpload(IMAGE_DEFAITE, "../images/defaite.png");
    serveurUpload(IMAGE_BONNET_FACE, "../images/bonnet_face.png");

    serveurNomRobot("MON ROBOT");

    serveurCaracRobot(3, 3, 2, 2);

    int attente = 0;
    while (!serveurRecevoirSituation(&jeu, &moi, &adversaire, &nbBoules, boule)) {
        printf("%d - Attente start\n", attente++);
    }

    while (1) {
        if (!serveurRecevoirSituation(&jeu, &moi, &adversaire, &nbBoules, boule)) {
            printf("Le serveur a mis fin  la connexion\n");
            break;
        }
        if (!(jeu.chrono % 100)) {
            printf("%d     %d     %d\n", moi.x, adversaire.x, etat);
        }

        // MACHINES A ETATS
// MACHINES A ETATS
        switch (etat) {
        case 0 :
            serveurStopperAction();
            if(moi.etat == ROBOT_IMMOBILE) {
                etat=1;
            }
            break;
        case 1 :
            serveurAvancer();
            if(moi.x >= 240) {
                etat=2;
            }
            break;
        case 2 :
            serveurStopperAction();
            if(moi.etat == ROBOT_IMMOBILE) {
                etat=3;
            }
            break;
        case 3 :
            serveurReculer();
            if (moi.x <= 80) {
                etat=0;
            }
            break;
        default :
            serveurNeRienChanger();
            etat = 0;
        }
        if (jeu.etat == JEU_ATTENTE) {
            break;
        } else if (jeu.etat == JEU_FIN_MATCH) {
            printf("Fin du match ");
            etat = 100;
        }
    }

    serveurFermer();
    printf("Serveur deconnecte\n");

    return 0;
}

/*
//EXERCICE 1

        // MACHINES A ETATS
        switch (etat) {
        case 0 :
            serveurStopperAction();
            if(moi.etat == ROBOT_IMMOBILE) {
                etat=1;
            }
            break;
        case 1 :
            serveurAvancer();
            if(moi.x >= 240) {
                etat=2;
            }
            break;
        case 2 :
            serveurStopperAction();
            if(moi.etat == ROBOT_IMMOBILE) {
                etat=3;
            }
            break;
        case 3 :
            serveurReculer();
            if (moi.x <= 80) {
                etat=0;
            }
            break;
        default :
            serveurNeRienChanger();
            etat = 0;
        }
*/

/*
//EXERCICE 2

        // MACHINES A ETATS
        switch (etat) {
        case 0 :
            serveurStopperAction();
            if(moi.etat == ROBOT_IMMOBILE) {
                etat=1;
            }
            break;
        case 1 :
            serveurSAccroupir();
            if(moi.etat == ROBOT_ACCROUPI) {
                etat=2;
            }
            break;
        case 2 :
            if (moi.neigeRassemblee) {
                serveurCompacterNeige(20);
            } else {
                serveurRassemblerNeige();
            }
            if(moi.nbBoule != 0) {
                etat=3;
            }
            break;
        case 3 :
            serveurSeRelever();
            if(moi.etat == ROBOT_IMMOBILE) {
                etat=0;
            }
            break;

        default :
            serveurNeRienChanger();
            etat = 0;
        }
*/
